VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Media Foundation IMFMediaEngine/Ex Sample"
   ClientHeight    =   5385
   ClientLeft      =   45
   ClientTop       =   390
   ClientWidth     =   12000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   359
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   800
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picSeek 
      Appearance      =   0  'Flat
      BackColor       =   &H00808080&
      ForeColor       =   &H80000008&
      Height          =   120
      Left            =   30
      ScaleHeight     =   90
      ScaleWidth      =   7170
      TabIndex        =   10
      Top             =   5220
      Width           =   7200
   End
   Begin VB.Timer tmNotify 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   7290
      Top             =   2790
   End
   Begin VB.Frame frVideo 
      Caption         =   "Video"
      Height          =   2685
      Left            =   8730
      TabIndex        =   8
      Top             =   60
      Width           =   3195
      Begin VB.HScrollBar sbColorControl 
         Height          =   195
         Index           =   3
         Left            =   1050
         Max             =   127
         Min             =   -127
         TabIndex        =   18
         Top             =   960
         Width           =   1995
      End
      Begin VB.HScrollBar sbColorControl 
         Height          =   195
         Index           =   2
         Left            =   1050
         Max             =   127
         Min             =   -127
         TabIndex        =   16
         Top             =   720
         Width           =   1995
      End
      Begin VB.HScrollBar sbColorControl 
         Height          =   195
         Index           =   1
         Left            =   1050
         Max             =   127
         Min             =   -127
         TabIndex        =   14
         Top             =   480
         Width           =   1995
      End
      Begin VB.HScrollBar sbColorControl 
         Height          =   195
         Index           =   0
         Left            =   1050
         Max             =   127
         Min             =   -127
         TabIndex        =   12
         Top             =   240
         Width           =   1995
      End
      Begin VB.CheckBox ckHorzMirror 
         Caption         =   "Horz. Mirror"
         Height          =   225
         Left            =   90
         TabIndex        =   9
         Top             =   2400
         Width           =   1125
      End
      Begin VB.Label lblColorControl 
         Alignment       =   1  'Right Justify
         Caption         =   "Saturation: "
         Height          =   195
         Index           =   3
         Left            =   90
         TabIndex        =   17
         Top             =   960
         Width           =   885
      End
      Begin VB.Label lblColorControl 
         Alignment       =   1  'Right Justify
         Caption         =   "Hue: "
         Height          =   195
         Index           =   2
         Left            =   90
         TabIndex        =   15
         Top             =   720
         Width           =   885
      End
      Begin VB.Label lblColorControl 
         Alignment       =   1  'Right Justify
         Caption         =   "Contrast: "
         Height          =   195
         Index           =   1
         Left            =   90
         TabIndex        =   13
         Top             =   480
         Width           =   885
      End
      Begin VB.Label lblColorControl 
         Alignment       =   1  'Right Justify
         Caption         =   "Brightness: "
         Height          =   195
         Index           =   0
         Left            =   90
         TabIndex        =   11
         Top             =   240
         Width           =   885
      End
   End
   Begin VB.Frame frAudio 
      Caption         =   "Audio"
      Height          =   2685
      Left            =   7290
      TabIndex        =   4
      Top             =   60
      Width           =   1395
      Begin VB.HScrollBar sbBalance 
         Height          =   195
         Left            =   90
         Max             =   100
         Min             =   -100
         TabIndex        =   7
         Top             =   240
         Width           =   1215
      End
      Begin VB.CheckBox ckMute 
         Caption         =   "Mute"
         Height          =   225
         Left            =   90
         TabIndex        =   6
         Top             =   2400
         Width           =   1125
      End
      Begin VB.VScrollBar sbVolume 
         Height          =   1875
         Left            =   600
         Max             =   0
         Min             =   100
         TabIndex        =   5
         Top             =   480
         Width           =   195
      End
   End
   Begin VB.PictureBox picVideo 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H00000000&
      BorderStyle     =   0  'None
      ForeColor       =   &H80000008&
      Height          =   4710
      Left            =   30
      ScaleHeight     =   4710
      ScaleWidth      =   7200
      TabIndex        =   3
      Top             =   480
      Width           =   7200
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   4890
      TabIndex        =   2
      Top             =   60
      Width           =   2340
   End
   Begin VB.CommandButton cmdPause 
      Caption         =   "Pause"
      Height          =   375
      Left            =   2460
      TabIndex        =   1
      Top             =   60
      Width           =   2340
   End
   Begin VB.CommandButton cmdPlay 
      Caption         =   "Play"
      Height          =   375
      Left            =   30
      TabIndex        =   0
      Top             =   60
      Width           =   2340
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 09/2020
'
' Das ist nur ein Beispiel/Testcode! Fr entsprechende Infos zu den Interfaces, die
' hier im Beispiel verwendet werden, und wie das ganze funktioniert, bitte die
' Media Foundation Doku lesen!
'
' In diesem Beispiel wird nur das Prinzip gezeigt wie die Interfaces IMFMediaEngine und
' IMFMediaEngineEx verwendet werden knnen um diverse Mediaquellen abzuspielen. Es sind
' zwar nicht alle Mglichkeiten in diesem Beispiel eingebaut, aber fr das Grobe reicht
' es und kann ja von jedem selbst erweitert werden.
'
' Die Funktion EventNotify vom Interface IMFMediaEngineNotify kann ohne ASM in VBC nicht
' verwendet werden. Die IDE bzw. der kompilierte Code strzen ohne ASM ab.

Option Explicit

' ----==== Variablen ====----
Private m_strStatus As String
Private m_bolIsNotify As Boolean
Private m_bolIsWebMedia As Boolean
Private m_dblDuration As Double
Private m_dblStartTime As Double
Private m_pIMFMediaEngine As Long
Private m_pIMFMediaEngineEx As Long
Private m_pIPropStoreColorControl As Long
Private m_pIMFVideoProcessorControl2 As Long

Private Sub Form_Load()

    Dim lngItem As Long
    Dim lngWait As Long
    Dim strURL As String
    Dim sngTimer As Single
    Dim dblCurTime As Double
    Dim eReadyState As MF_MEDIA_ENGINE_READY
    Dim eD3D11VPASC As D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS
    
    m_bolIsNotify = False
    m_bolIsWebMedia = False
    m_dblStartTime = -1
    m_strStatus = "Stopped"
    
    tmNotify.Enabled = False
    tmNotify.Interval = 1 ' Ja ich weis. Der VB-Timer kann keine 1ms. ;-)
    
    cmdPlay.Enabled = False
    cmdPause.Enabled = False
    cmdStop.Enabled = False
    
    ckMute.Enabled = False
    ckHorzMirror.Enabled = False
    
    With sbVolume
        .Enabled = False
        .Max = 0
        .Min = 100
    End With
    
    With sbBalance
        .Enabled = False
        .Max = 100
        .Min = -100
    End With
    
    For lngItem = 0 To sbColorControl.Count - 1
        sbColorControl(lngItem).Enabled = False
    Next lngItem
    
    With picVideo
        .AutoRedraw = True
        .BackColor = vbBlack
        .ForeColor = vbWhite
        .ScaleMode = vbPixels
        .FontSize = 16
    End With
    
    picSeek.Enabled = False
    picSeek.BackColor = &HC0C0C0
    
    Me.Caption = "Bitte warten"
    Me.Show
    
    DoEvents
    
    ' ----==== diverse Mediaquellen ====----
    '
    ' zB. frei verfgbare WebRadio-Streams
    'strURL = "http://tunein.t4e.dj/hard/dsl/mp3"
    'strURL = "http://listen.technobase.fm/tunein-mp3-pls"
    'strURL = "https://intenseradio.live-streams.nl:18000/low"
    'strURL = "http://www.schwarze-welle.de:7500"
    
    ' zB. frei verfgbare WebTV-Streams
    strURL = "https://derste247livede.akamaized.net/hls/live/658317-b/daserste_de/profile1/1.m3u8"
    'strURL = "https://zdf-hls-15.akamaized.net/hls/live/2016498/de/high/master.m3u8"
    'strURL = "https://ndrfs-lh.akamaihd.net/i/ndrfs_hh@430231/index_3776_av-p.m3u8"
    'strURL = "https://rbblive-lh.akamaihd.net/i/rbb_berlin@144674/index_5_av-p.m3u8"
    'strURL = "https://1000338copo-app2749759488.r53.cdn.tv1.eu/1000518lf/1000338copo/live/app2749759488/w2928771075/live247.smil/playlist.m3u8"
    'strURL = "https://tv.artcom-venture.de/dmf/tv_720.m3u8"
    'strURL = "https://unilivemtveu-lh.akamaihd.net/i/mtvde_1@134922/index_3500_av-b.m3u8"
    'strURL = "https://unilivemtveu-lh.akamaihd.net/i/nickde_1@448749/master.m3u8"
    'strURL = "https://10999-1.b.cdn13.com/hls/new/community/community-683.mp4/index.m3u8"
    
    ' Lokale Mediadateien
    'strURL = App.Path & "\test.mp3"
    'strURL = App.Path & "\test.mp4"
    
    ' Mediadateien im Netzwerk
    ' strURL = "\\Server\Media.wav"
    
    ' Media Foundation starten
    If MFStartup(MF_VERSION, MF_STARTUP_FULL) = S_OK Then
    
        ' Interfaces IMFMediaEngine und IMFMediaEngineEx erstellen
        If CreateMediaEngine(m_pIMFMediaEngine, m_pIMFMediaEngineEx, _
            picVideo.hWnd, RenderingMode) = True Then
            
            ' Notify-Timer starten
            m_bolIsNotify = True
            tmNotify.Enabled = True
            
            ' Optional, Effekte mssen vor dem laden einer Mediaquelle erstellt und hinzugefgt werden
            '
            ' ein ColorControlDmo-Effekt erstellen (IPropertyStore)
            If CreateColorControl(m_pIPropStoreColorControl) = True Then

                ' ColorControlDMO als Video Effekt hinzufgen
                If Invoke(m_pIMFMediaEngineEx, InsertVideoEffect, vbLong, _
                    m_pIPropStoreColorControl, API_TRUE) = S_OK Then

                End If

            End If
            
            ' ein IMFVideoProcessorControl2 Interface erstellen
            If CreateVideoProcessorControl(m_pIMFVideoProcessorControl2) = True Then

                ' IMFVideoProcessorControl2 als Video Effekt hinzufgen
                If Invoke(m_pIMFMediaEngineEx, InsertVideoEffect, vbLong, _
                    m_pIMFVideoProcessorControl2, API_TRUE) = S_OK Then
                
                End If
                
            End If


            ' ist ein String vorhanden
            If Len(strURL) > 0& Then
            
                ' Mediaquelle festlegen
                If Invoke(m_pIMFMediaEngine, SetSource, vbLong, strURL) = S_OK Then
                
                    ' warten bis alle Daten zur Verfgung stehen oder der TimeOut eintritt
                    sngTimer = Timer
                    lngItem = 0
                    
                    Do
                    
                        DoEvents
                        
                        ' nach 10 Sekunden TimeOut
                        If Timer - sngTimer >= 10 Then Exit Do
                        
                        ' ReadyState ermitteln
                        eReadyState = Invoke(m_pIMFMediaEngine, GetReadyState, vbInteger)
                            
                        lngItem = lngItem + 1
                        
                        If lngItem = 2000 Then
                        
                            lngItem = 0
                            lngWait = lngWait + 1
                            
                            Me.Caption = "Bitte warten" & String$(lngWait, ".")
                            
                            If lngWait = 10 Then lngWait = 0
                            
                        End If
                        
                    Loop Until eReadyState = MF_MEDIA_ENGINE_READY_HAVE_ENOUGH_DATA
                    
                    
                    ' nur wenn alle Daten zur Verfgung stehen
                    If eReadyState = MF_MEDIA_ENGINE_READY_HAVE_ENOUGH_DATA Then
                    
                        ' ----==== Optional ====----
                        '
                        ' Supported Hardware Effekte ermitteln, geht erst nach
                        ' dem laden einer Mediaquelle
                        If Invoke(m_pIMFVideoProcessorControl2, GetSupportedHardwareEffects, _
                            vbLong, VarPtr(eD3D11VPASC)) = S_OK Then
                            
                            ' Debug.Print "----==== Supported Hardware Effects ====----"
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_DENOISE) = True Then
                                
                                ' Debug.Print "DENOISE"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_DERINGING) = True Then
                                
                                ' Debug.Print "DERINGING"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_EDGE_ENHANCEMENT) = True Then
                                
                                ' Debug.Print "EDGE_ENHANCEMENT"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_COLOR_CORRECTION) = True Then
                                
                                ' Debug.Print "COLOR_CORRECTION"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_FLESH_TONE_MAPPING) = True Then
                                
                                ' Debug.Print "FLESH_TONE_MAPPING"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_IMAGE_STABILIZATION) = True Then
                                
                                ' Debug.Print "IMAGE_STABILIZATION"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_SUPER_RESOLUTION) = True Then
                                
                                ' Debug.Print "SUPER_RESOLUTION"
                                
                            End If
                            
                            If CBool(eD3D11VPASC And _
                                D3D11_VIDEO_PROCESSOR_AUTO_STREAM_CAPS_ANAMORPHIC_SCALING) = True Then
                                
                                ' Debug.Print "ANAMORPHIC_SCALING"
                                
                            End If
                            
                            ' sind Hardware Effekte vorhanden
                            If eD3D11VPASC <> 0& Then
                            
                                ' Optional, Hardware Effekte aktivieren
                                If Invoke(m_pIMFVideoProcessorControl2, EnableHardwareEffects, _
                                    vbLong, API_TRUE) = S_OK Then
                                    
                                    ' Debug.Print "Hardware Effects Enabled = True"
                                    
                                End If
                                
                            End If
                            
                        End If
                        
                        
                        ' enthlt die Mediaquelle ein Audio
                        If Invoke(m_pIMFMediaEngine, HasAudio, vbBoolean) Then
                        
                            ' Volume ermitteln und Scrollbar setzen
                            With sbVolume
                            
                                .Enabled = True
                                
                                .Value = Invoke(m_pIMFMediaEngine, GetVolume, vbDouble) * 100
                                    
                            End With
                            
                            ' Balance ermitteln und Scrollbar setzen
                            With sbBalance
                            
                                .Enabled = True
                                
                                .Value = Invoke(m_pIMFMediaEngineEx, GetBalance, vbDouble) * 100
                                    
                            End With
                            
                            ' Mute ermitteln und Checkbox setzen
                            ckMute.Enabled = True
                            
                            ckMute.Value = IIf(Invoke(m_pIMFMediaEngine, GetMuted, vbBoolean), 1, 0)
                                
                        End If
                        
                        ' enthlt die Mediaquelle ein Video
                        If Invoke(m_pIMFMediaEngine, HasVideo, vbBoolean) Then
                        
                            ckHorzMirror.Enabled = True
                            ckHorzMirror.Value = vbUnchecked
                            
                        Else
                        
                            picVideo.CurrentX = 5
                            picVideo.CurrentY = 5
                            picVideo.Print "Die Medienquelle enthlt kein Video!"
                            
                        End If
                        
                        ' Duration der Mediaquelle ermitteln
                        m_dblDuration = Invoke(m_pIMFMediaEngine, GetDuration, vbDouble)
                            
                        ' nur wenn die Duration unendlich ist
                        ' zb bei WebRadio/WebTV
                        If CStr(m_dblDuration) = "1,#INF" Or CStr(m_dblDuration) = "1,#QNAN" Then
                            
                            m_dblDuration = 0
                            m_bolIsWebMedia = True
                            cmdStop.Visible = False
                            cmdPause.Caption = "Stop"
                            
                        Else
                        
                            m_bolIsWebMedia = False
                            cmdStop.Visible = True
                            cmdPause.Caption = "Pause"
                            
                            picSeek.Cls
                            picSeek.Enabled = True
                            picSeek.BackColor = &HC000&
                            picSeek.Scale (0, 0)-(m_dblDuration, 1)
                            
                        End If
                        
                        If m_dblDuration = 0 Then
                        
                            Me.Caption = m_strStatus & ": " & Dbl2Time(0)
                            
                        Else
                        
                            Me.Caption = m_strStatus & ": " & Dbl2Time(0) & _
                                " von " & Dbl2Time(m_dblDuration)
                                
                        End If
                        
                        ' CurrentTime auslesen
                        dblCurTime = CDbl(CStr(Invoke(m_pIMFMediaEngine, GetCurrentTime, vbDouble)))
                            
                        ' StartTime = CurrentTime
                        If m_dblStartTime = -1 Then m_dblStartTime = dblCurTime
                        
                    Else
                    
                        picVideo.CurrentX = 5
                        picVideo.CurrentY = 5
                        
                        picVideo.Print "Die Medienquelle konnte nicht geladen werden!"
                            
                        Me.Caption = "Fehler"
                        
                        ' alle Interfaces freigeben
                        Call ReleaseAll
                        
                    End If
                    
                Else
                
                    picVideo.CurrentX = 5
                    picVideo.CurrentY = 5
                    picVideo.Print "Fehler beim laden der Medienquelle!"
                    Me.Caption = "Fehler"
                    
                    ' alle Interfaces freigeben
                    Call ReleaseAll
                    
                End If
                
            Else
            
                picVideo.CurrentX = 5
                picVideo.CurrentY = 5
                picVideo.Print "Keine Medienquelle vorhanden!"
                Me.Caption = "Fehler"
                
                ' alle Interfaces freigeben
                Call ReleaseAll
                
            End If
            
        End If
        
    End If
    
End Sub

Private Sub cmdPlay_Click()
    
    Dim lngItem As Long
    
    If PlayMedia = True Then
    
        m_strStatus = "Playing"
        cmdPlay.Enabled = False
        cmdPause.Enabled = True
        If m_bolIsWebMedia = False Then cmdStop.Enabled = True
        
        If Invoke(m_pIMFMediaEngine, HasVideo, vbBoolean) Then
        
            For lngItem = 0 To sbColorControl.Count - 1
            
                sbColorControl(lngItem).Enabled = True
                
            Next lngItem
        
        End If
                
    End If
    
End Sub

Private Sub cmdPause_Click()

    Dim lngItem As Long
    
    If PauseMedia = True Then
    
        cmdPlay.Enabled = True
        cmdPause.Enabled = False
        
        If m_bolIsWebMedia = False Then
        
            m_strStatus = "Paused"
            cmdStop.Enabled = True
            
        Else
        
            m_strStatus = "Stopped"
            
        End If
        
        If Invoke(m_pIMFMediaEngine, HasVideo, vbBoolean) Then
        
            For lngItem = 0 To sbColorControl.Count - 1
            
                sbColorControl(lngItem).Enabled = False
                
            Next lngItem
        
        End If
    
    End If

End Sub

Private Sub cmdStop_Click()

    Dim lngItem As Long

    If StopMedia = True Then
    
        m_strStatus = "Stopped"
        cmdPlay.Enabled = True
        cmdPause.Enabled = False
        cmdStop.Enabled = False
        
        If Invoke(m_pIMFMediaEngine, HasVideo, vbBoolean) Then
        
            For lngItem = 0 To sbColorControl.Count - 1
            
                sbColorControl(lngItem).Enabled = False
                
            Next lngItem
        
        End If
        
    
    End If

End Sub

Private Sub picSeek_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)

    If picSeek.Enabled = True Then
        
        If Button = vbLeftButton Then
        
            Call Invoke(m_pIMFMediaEngineEx, SetCurrentTimeEx, vbLong, CDbl(X), _
                MF_MEDIA_ENGINE_SEEK_MODE.MF_MEDIA_ENGINE_SEEK_MODE_APPROXIMATE)
    
        End If
    
    End If

End Sub

Private Sub picSeek_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    
    If picSeek.Enabled = True Then
    
        picSeek.ToolTipText = "Position: " & Dbl2Time(X)
        
    End If
    
End Sub

Private Sub picSeek_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
'
End Sub

Private Sub sbBalance_Change()
    
    Call sbBalance_Scroll
    
End Sub

Private Sub sbBalance_Scroll()

    ' Balance setzen
    Call Invoke(m_pIMFMediaEngineEx, SetBalance, vbLong, _
        CDbl(sbBalance.Value / 100))
    
End Sub

Private Sub sbColorControl_Change(Index As Integer)
    
    Call sbColorControl_Scroll(Index)
    
End Sub

Private Sub sbColorControl_Scroll(Index As Integer)

    Dim dblCurTime As Double
    Dim tPropKey As PROPERTYKEY
    Dim tPropVar As PROPVARIANT
    
    With tPropKey
    
        .fmtid = Str2Guid(MFPKEY_COLOR_FMTID)
        
        Select Case Index
        
        Case 0
            .pid = MFPKEY_COLOR_PID.BRIGHTNESS
            
        Case 1
            .pid = MFPKEY_COLOR_PID.CONTRAST
            
        Case 2
            .pid = MFPKEY_COLOR_PID.HUE
            
        Case 3
            .pid = MFPKEY_COLOR_PID.SATURATION
            
        End Select
        
    End With
    
    ' max 127
    If sbColorControl(Index).Value <= 127 Then
    
        ' min -127
        If sbColorControl(Index).Value >= -127 Then
            
            With tPropVar
                .vt = VT_I4
                .vData = CLng(sbColorControl(Index).Value)
            End With
    
            If Invoke(m_pIPropStoreColorControl, SetValue, vbLong, _
                VarPtr(tPropKey), VarPtr(tPropVar)) = S_OK Then
        
                Call PropVariantClear(tPropVar)
        
            End If
            
        End If
    
    End If
        
End Sub

Private Sub sbVolume_Change()

    Call sbVolume_Scroll
    
End Sub

Private Sub sbVolume_Scroll()
    
    ' Volume setzen
    Call Invoke(m_pIMFMediaEngine, SetVolume, vbLong, _
        CDbl(sbVolume.Value / 100))
    
End Sub

Private Sub ckMute_Click()
    
    ' Mute setzen
    Call Invoke(m_pIMFMediaEngine, SetMuted, vbLong, _
        IIf(ckMute.Value, API_TRUE, API_FALSE))

End Sub

Private Sub ckHorzMirror_Click()
                                        
    ' HorizontalMirror setzen
    Call Invoke(m_pIMFMediaEngineEx, EnableHorizontalMirrorMode, _
        vbLong, IIf(ckHorzMirror.Value, API_TRUE, API_FALSE))

End Sub

Private Sub tmNotify_Timer()

    Dim dblCurTime As Double
    Dim lngCurParam1 As Long
    Dim lngCurParam2 As Long
    Dim eCurEvent As MF_MEDIA_ENGINE_EVENT
    
    ' nur wenn aktiv
    If m_bolIsNotify = True Then
    
        ' timer stoppen
        tmNotify.Enabled = False
        
        ' Events vom IMFMediaEngineNotify holen
        If modIMFMediaEngineNotify.GetEvents(eCurEvent, lngCurParam1, lngCurParam2) = True Then
        
            ' Events auswerten
            Select Case eCurEvent
            
            Case MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_CANPLAYTHROUGH, _
                MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_PLAY
                
                ' Play-Button
                cmdPlay.Enabled = True
            
            Case MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_DURATIONCHANGE
            
                ' Duration der Mediaquelle ermitteln
                m_dblDuration = Invoke(m_pIMFMediaEngine, GetDuration, vbDouble)
                
                ' nur wenn die Duration unendlich ist, zb bei WebRadio/WebTV
                If CStr(m_dblDuration) = "1,#INF" Or _
                    CStr(m_dblDuration) = "1,#QNAN" Then
                    
                    m_dblDuration = 0
                    
                End If
                
            Case MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_TIMEUPDATE, _
                MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_PAUSE
                
                ' CurrentTime auslesen
                dblCurTime = CDbl(CStr(Invoke(m_pIMFMediaEngine, _
                    GetCurrentTime, vbDouble))) - m_dblStartTime
                
                If m_dblDuration = 0 Then
                
                    Me.Caption = m_strStatus & ": " & Dbl2Time(dblCurTime)
                    
                Else
                
                    Me.Caption = m_strStatus & ": " & Dbl2Time(dblCurTime) & _
                        " von " & Dbl2Time(m_dblDuration)
                        
                    picSeek.Cls
                    picSeek.Line (0, 0)-(dblCurTime, 1), vbRed, BF
                        
                End If
                
            Case MF_MEDIA_ENGINE_EVENT.MF_MEDIA_ENGINE_EVENT_ENDED
            
                ' wiedergabe stoppen
                If StopMedia = True Then
                
                    m_strStatus = "Stopped"
                    cmdPlay.Enabled = True
                    cmdPause.Enabled = False
                    cmdStop.Enabled = False
                    
                    If m_dblDuration = 0 Then
                    
                        Me.Caption = m_strStatus & ": " & Dbl2Time(dblCurTime)
                        
                    Else
                    
                        Me.Caption = m_strStatus & ": " & Dbl2Time(dblCurTime) _
                            & " von " & Dbl2Time(m_dblDuration)
                            
                        picSeek.Cls
                        picSeek.Line (0, 0)-(dblCurTime, 1), vbRed, BF
                            
                    End If
                
                End If
                
            End Select
        
        End If
        
    End If
    
    tmNotify.Enabled = m_bolIsNotify
    
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    ' Timer stoppen
    m_bolIsNotify = False
    tmNotify.Enabled = False

    ' Wiedergabe stoppen falls noch luft
    If m_strStatus = "Playing" Then
    
        Call Invoke(m_pIMFMediaEngine, Pause, vbLong)
        
    End If

    ' alle Interfaces freigeben
    Call ReleaseAll

End Sub

Private Sub Form_Unload(Cancel As Integer)

    ' Media Foundation herunterfahren
    Call MFShutdown
    
End Sub

Private Sub ReleaseAll()
    
    ' alle hinzugefgte Effekte entfernen
    Call Invoke(m_pIMFMediaEngineEx, RemoveAllEffects, vbLong)
    
    ' IMFMediaEngine herunterfahren
    Call Invoke(m_pIMFMediaEngine, Shutdown, vbLong)

    ' alle Interfaces freigeben
    Call Release(m_pIPropStoreColorControl)
    Call Release(m_pIMFVideoProcessorControl2)
    Call Release(m_pIMFMediaEngineEx)
    Call Release(m_pIMFMediaEngine)
    
End Sub

Private Function CreateMediaEngine(ByRef pMediaEngine As Long, _
    ByRef pMediaEngineEx As Long, Optional ByVal hRenderWnd As Long = 0&, _
    Optional ByVal eEngineMode As EngineMode = RenderingMode, _
    Optional ByVal eAudioStreamCategory As AUDIO_STREAM_CATEGORY = AudioCategory_Media, _
    Optional ByVal eAudioDeviceRole As ERole = eMultimedia) As Boolean
    
    Dim bolRet As Boolean
    Dim pIMFAttributes As Long
    Dim pIMFMediaEngineClassFactory As Long
    Dim eCreateFlags As MF_MEDIA_ENGINE_CREATEFLAGS
    
    bolRet = False
    
    ' IMFMediaEngineClassFactory Interface erstellen
    If CreateInterface(CLSID_MFMediaEngineClassFactory, _
        IID_IMFMediaEngineClassFactory, _
        pIMFMediaEngineClassFactory) = True Then
        
        ' IMFAttributes Interface erstellen
        If MFCreateAttributes(pIMFAttributes, 0&) = S_OK Then
    
            ' Callback Interface festlegen
            If Invoke(pIMFAttributes, SetUnknown, vbLong, _
                VarPtr(Str2Guid(MF_MEDIA_ENGINE_CALLBACK)), _
                modIMFMediaEngineNotify.pIMFMediaEngineNotify) = S_OK Then
                
                ' AudioStreamCategory festlegen
                If Invoke(pIMFAttributes, SetUINT32, vbLong, _
                    VarPtr(Str2Guid(MF_MEDIA_ENGINE_AUDIO_CATEGORY)), _
                    eAudioStreamCategory) = S_OK Then
            
                    ' AudioDeviceRole festlegen
                    If Invoke(pIMFAttributes, SetUINT32, vbLong, _
                        VarPtr(Str2Guid(MF_MEDIA_ENGINE_AUDIO_ENDPOINT_ROLE)), _
                        eAudioDeviceRole) = S_OK Then
                        
                        ' nach EngineMode selektieren
                        Select Case eEngineMode
                        
                        ' nur AudioMode
                        Case EngineMode.AudioMode
                            
                            eCreateFlags = MF_MEDIA_ENGINE_AUDIOONLY
                            
                            bolRet = True
                            
                        ' nur RenderingMode
                        Case EngineMode.RenderingMode
                        
                            eCreateFlags = MF_MEDIA_ENGINE_STANDARD
                        
                            ' nur wenn ein Fensterhandle vorhanden ist
                            If hRenderWnd <> 0& Then
        
                                ' Fensterhandle fr die Videoausgabe festlegen
                                If Invoke(pIMFAttributes, SetUINT64, vbLong, _
                                    VarPtr(Str2Guid(MF_MEDIA_ENGINE_PLAYBACK_HWND)), _
                                    hRenderWnd, 0&) = S_OK Then
                    
                                    bolRet = True
                    
                                End If
                            
                            End If
        
                        ' nur FrameServerMode
                        Case EngineMode.FrameServerMode
                            
                            eCreateFlags = MF_MEDIA_ENGINE_STANDARD
                            
                            ' Video-Outputformat festlegen
                            If Invoke(pIMFAttributes, SetUINT32, vbLong, _
                                VarPtr(Str2Guid(MF_MEDIA_ENGINE_VIDEO_OUTPUT_FORMAT)), _
                                D3DFMT_R8G8B8) = S_OK Then
                    
                                bolRet = True
                    
                            End If
                        
                        End Select
                        
                        If bolRet = True Then
                        
                            ' IMFMediaEngine Interface erstellen
                            If Invoke(pIMFMediaEngineClassFactory, CreateInstance, vbLong, _
                                eCreateFlags, pIMFAttributes, VarPtr(pMediaEngine)) = S_OK Then
                
                                ' IMFMediaEngineEx Interface erstellen
                                If Invoke(pMediaEngine, QueryInterface, vbLong, _
                                    VarPtr(Str2Guid(IID_IMFMediaEngineEx)), _
                                    VarPtr(pMediaEngineEx)) = S_OK Then
                    
                                    bolRet = True
                    
                                End If
                
                            End If
                        
                        End If
                        
                    End If
                    
                End If
                
            End If
        
            ' aufrumen
            Call Release(pIMFAttributes)
            
        End If
        
        ' aufrumen
        Call Release(pIMFMediaEngineClassFactory)
        
    End If
    
    CreateMediaEngine = bolRet
    
End Function

Private Function PlayMedia() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False
    
    ' Wiedergabe starten
    If Invoke(m_pIMFMediaEngine, Play, vbLong) = S_OK Then
    
        bolRet = True
       
    End If

    PlayMedia = bolRet
    
End Function

Private Function PauseMedia() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    ' Wiedergabe pausieren
    If Invoke(m_pIMFMediaEngine, Pause, vbLong) = S_OK Then
        
        bolRet = True
    
    End If

    PauseMedia = bolRet
    
End Function

Private Function StopMedia() As Boolean

    Dim bolRet As Boolean
    
    bolRet = False

    ' Wiedergabe pausieren
    If Invoke(m_pIMFMediaEngine, Pause, vbLong) = S_OK Then
    
        ' zurck zum Anfang der Wiedergabe gehen
        If Invoke(m_pIMFMediaEngine, SetCurrentTime, vbLong, CDbl(0)) = S_OK Then
    
            bolRet = True
        
        End If
    
    End If

    StopMedia = bolRet
    
End Function

Private Function CreateVideoProcessorControl(ByRef pVideoProcessorControl2 As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    ' ein IMFVideoProcessorControl2 Interface erstellen
    If CreateInterface(CLSID_VideoProcessorMFT, _
        IID_IMFVideoProcessorControl2, _
        pVideoProcessorControl2) = True Then
    
        bolRet = True
        
    End If
    
    CreateVideoProcessorControl = bolRet
    
End Function

Private Function CreateColorControl(ByRef pIPropStoreColorControl As Long) As Boolean
    
    Dim bolRet As Boolean
    
    bolRet = False
    
    ' ein IPropertyStore Interface erstellen
    If CreateInterface(CLSID_CColorControlDMO, _
        IID_IPropertyStore, _
        pIPropStoreColorControl) = True Then
    
            bolRet = True
                    
    End If
    
    CreateColorControl = bolRet
    
End Function

